<!DOCTYPE html>
<html lang="en">

<head>
	<title>CCLD Lidar Admin Panel</title>
	<meta charset="utf-8" />
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" />
	<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto" />
	<link rel="stylesheet" type="text/css" href="/css/admin.css?v=<?=CACHEBUST?>" />
	<link rel="stylesheet" type="text/css" href="/css/spinkit-loader.css" />
	<link rel="shortcut icon" href="daktylos.png" type="image/png" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0" />
	<meta name="author" content="Justin Gilman" />
	<meta name="description" content="The management page for controlling clients and access to the Lidar data" />
	<meta name="robots" content="none" />
</head>
<body>
	<header id="header">
		<div id="navigation">
			<ul>
				<li><a id="dashboard-tab" href="/dashboard/">Dashboard</a></li>
				<li><a id="accounts-tab" href="/dashboard/accounts/">Accounts</a></li>
				<li><a id="users-tab" href="/dashboard/users/">Users</a></li>
				<li><a id="data-tab" href="/dashboard/data/">Data</a></li>
			</ul>
		</div>
		<div id="login-controls">Logged in as <?=$displayName?> 
			<button id="logout" alt="Logout"></button>
		</div>
	</header>
	<div id="header-spacer"></div>
	<script type="text/javascript" src="/js/ajax.js?v=<?=CACHEBUST?>"></script>
	<script type="text/javascript" src="/js/notification.js?v=<?=CACHEBUST?>"></script>
	<script type="text/javascript">
		var logoutButton = document.getElementById("logout");
		logoutButton.addEventListener('click', function() { 
			var promise = ajaxPost("/api/logout", {});

			promise.success = function(response) {
				window.location = "/dashboard/";
			};

			promise.failure = function(response) {
				console.warn("Communication failure", response);
			}
		}, false);


	</script>